package RPM::Source::Convert::Plugins::PLD2ALT;
use strict;
use warnings;
#use Carp;

use RPM::Source::Transformation::Factory;
use RPM::Source::Transformation::OptHandlerWrapper;
use RPM::Source::Convert::Plugins::Generic2ALT;
use RPM::Source::Transformation::Factory::Buildreq;
use RPM::Source::Shared::Resource::DistroMap;

# for: bcond_with macro expansion
# TODO: move to Generic2ALT
use RPM::Source::Convert::Plugins::Fedora2ALT;

our @ISA=qw/RPM::Source::Transformation::Factory/;
push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

$DistroMap::default_originrepo='pld';
$DistroMap::default_originbranch=undef;

sub transformations {
    return 
	RPM::Source::Transformation::OptHandlerWrapper->new(
	    -priority => PRIORITY_CONVERT,
	    -name => 'pld2alt_convert',
	    -opt_handler_sub=>\&opt_handler_pld2alt_convert);
}

sub opt_handler_pld2alt_convert {
    my (undef,$spec,$parent,$opt,$resourceobj)=@_;
    my $mainsec=$spec->main_section;
    my ($flag_macro_pld,$flag_need_pld_compat);
    foreach my $sec ($spec->get_sections()) {
	my $t = $sec->get_type();
	if ($t eq 'package') {
#	    $sec->exclude_body(qr'^\s*Autoreqprov: on');
	} elsif ($t eq 'build') {
	    $sec->map_body(sub {
		# no more we have __global_ldflags
		s,(?<!%)\%{rpmldflags},,g;
		s,(?<!%)\%rpmldflags,,g;
		s,(?<!%)\%{rpmcflags},%{optflags},g;
		s,(?<!%)\%rpmcflags,%optflags,g;
			   });

	} elsif ($t eq 'install') {
	} elsif ($RPM::Source::SpecSection::SCRIPT_SECTION{$t}) {
	    $sec->exclude_body(qr'(?<!%)\%{?(?:run_ldconfig)}?');
	} elsif ($t eq 'files') {
	}
	# general hacks here
	#$flag_macro_pld=1 if not $flag_macro_pld and $sec->match_body(qr'(?<!%)\%{\??pld_version}');

    }
    #$mainsec->unshift_body('%define pld_version '.$PLD_VERSION."\n") if $flag_macro_pld;

    my $buildreq=$resourceobj->buildreq;
    $buildreq->add_pre_buildreq('rpm-build-pld-compat') if $flag_need_pld_compat;
    return RPM::Source::Transformation::Factory::TRANSFORMATION_OK;
}

1;

__END__
